        CPU   "Z180.TBL"
        HOF   "INT8"

        ORG   8000H
CNTR    EQU   0AH
TRDR    EQU   0BH
CNTLA0  EQU   0
;
BIT_TX  EQU   4
BIT_RX  EQU   5
BIT_RTS EQU   4
;
DAT_AREA EQU  9000H
;
;/* examples routine */
; for 93c46  write/read
; need select jumper to RTS0
; PIN1 CS=RTS0
; PIN2 SK=CKS
; PIN3 DI=TXS
; PIN4 DO=RXS

        LD    B,128
        LD    A,0
        LD    HL,DAT_AREA        ;Set data area  00h-7Fh
EXAM1:  LD    (HL),A
        INC   HL
        INC   A
        DJNZ  EXAM1
;
        LD    IX,DAT_AREA         ;Write block 93c46 (8bit)
        CALL  WB5616               ;write 00-7f

        LD    HL,DAT_AREA
        LD    DE,DAT_AREA+1
        LD    (HL),0
        LD    BC,128-1
        LDIR
;
        LD    IX,DAT_AREA          ;Read blocck 93c46 (8bit)
        CALL  RB5616
;
        RST   18H                  ;END. PRG

;
;/* Subroutine to serial eeprom  */
;   control by Z180 (csio port)

;***********************
;     WRITE  46,56,66  *
;***********************
;  I/P = A ( address 00-63 (00H-3FH) )
;      = HL ( DATA H=high, L=low )
;  REG = ALL

WR4616:   LD    DE,1         ;Write 16 bit 93c46
          CALL  WR16
          RET
;
;/* WRITE 93C56 & 93C66 16 BIT */
; I/P = A,HL
; ADDRESS  00-127 (00H-7FH) FOR 93C56
;          00-255 (00H-FFH) FOR 93C66

WR5616:
WR6616:   LD    DE,3
          CALL  WR16
          RET
;
;/* WRITE 93C46 8 BIT */
; I/P = A ( address 00-127 (00h-7FH) )
;       L ( data )

WR468:    LD    DE,2
          CALL  WR8
          RET
;
;/*  WRITE 93C56 & 93C56  8 BIT */
; I/P = A,L (93C56)
; ADDRESS  00-255 (00H-FFH)  FOR 93C56
;          00-511 (00H-1FFH) FOR 93C66
; I/P =  A,D (93C66), (ADDRESS D=high bute (0,1), A=00H-FFH)
;        L DATA

WR568:    LD    D,0
WR668:    LD    E,4
          PUSH  AF
          LD    A,D
          AND   01H
          LD    D,A
          POP   AF
          CALL  WR8
          RET
;
;***********************
;     READ 46,56,66    *
;***********************
;  I/P = A ( address 00-63 (00H-3FH) )
;  O/P = HL ( DATA H=high, L=low )
;  REG = ALL

RD4616:   LD    DE,1              ;READ 93C46 16 BIT
          CALL  RD16
          RET
;
;/* READ 93C56 & 93C66 16 BIT */
; I/P = A
; O/P = HL
; ADDRESS  00-127 (00H-7FH) FOR 93C56
;          00-255 (00H-FFH) FOR 93C66
RD5616:
RD6616:   LD    DE,3
          CALL  RD16
          RET
;
;/* READ 93C46 8 BIT */
; I/P = A ( address 00-127 (00h-7FH) )
; O/P = L ( data )

RD468:    LD    DE,2
          CALL  RD8
          RET
;
;/*  READ 93C56 & 93C56  8 BIT */
; I/P = A  (93C56)
; ADDRESS  00-255 (00H-FFH)  FOR 93C56
;          00-511 (00H-1FFH) FOR 93C66
; I/P =  A,D (93CC56), (ADDRESS D=high bute (0,1), A=00H-FFH)
;        L DATA

RD568:    LD    D,0
RD668:    LD    E,4
          PUSH  AF
          LD    A,D
          AND   1
          LD    D,A
          POP   AF
          CALL  RD8
          RET
;
;**************************
; WRITE BLOCK 93C46 16 BIT*
;**************************
; I/P = IX (Memory address for fill data 64 word)
; REG = ALL

WB4616:   LD    B,64              ;word
          LD    DE,1
          CALL  WR_BL16
          RET
;
;**************************
; WRITE BLOCK 93C46 8 BIT *
;**************************
; I/P = IX (Memory address for fill data 128 byte)
; REG = ALL

WB468:    LD    B,128
          LD    DE,2
          CALL  WR_BL8
          RET

;**************************
; WRITE BLOCK 93C56 16 BIT*
;             93C66       *
;**************************
; I/P = IX (Memory address for fill data 128 word) 93c56
; REG = ALL

WB5616:   LD    B,128
          JR    WB2

; I/P = IX (Memory address for fill data 256 word) 93c66
; REG = ALL

WB6616:   LD    B,0          ;256
WB2:      LD    DE,3
          CALL  WR_BL16
          RET
;
;**************************
; WRITE BLOCK 93C56 8 BIT *
;**************************
; I/P = IX (Memory address for fill data 256 byte) 93c56
; REG = ALL

WB568:    LD    DE,4
WB5681:   LD    B,0                    ;256 BIT
          CALL  WR_BL8
          RET

;**************************
; WRITE BLOCK 93C66 8 BIT *
;**************************
; I/P = IX (Memory address for fill data 512 byte) 93c66
; REG = ALL

WB668:    CALL  WB568
          LD    DE,104H
          CALL  WB5681
          RET
;
;**************************
; READ BLOCK 93C46 16 BIT *
;**************************
; read data eeprom 93cxx to memory in to (IX)
; I/P = IX (Memory address for fill data 64 word)
; REG = ALL

RB4616:   LD    B,64
          LD    DE,1
          CALL  RD_BL16
          RET

;**************************
; READ BLOCK 93C46 8 BIT  *
;**************************
; I/P = IX (Memory address for fill data 128 byte)
; REG = ALL

RB468:    LD    B,128
          LD    DE,2
          CALL  RD_BL8
          RET

;**************************
; READ BLOCK 93C56 16 BIT *
;            93C66        *
;**************************
; I/P = IX (Memory address for fill data 128 word) 93c56
; REG = ALL
;
RB5616:   LD    B,128
          JR    RB2

; I/P = IX (Memory address for fill data 256 word) 93c66
; REG = ALL

RB6616:   LD    B,0            ;256
RB2:      LD    DE,3
          CALL  RD_BL16
          RET

;**************************
; READ BLOCK 93C56 8 BIT  *
;**************************
; I/P = IX (Memory address for fill data 256 byte) 93c56
; REG = ALL
;
RB568:    LD    DE,4
RB5681:   LD    B,0            ;256
          CALL  RD_BL8
          RET

;**************************
; READ BLOCK 93C66 8 BIT  *
;**************************
; I/P = IX (Memory address for fill data 512 byte) 93c66
; REG = ALL
;
RB668:    CALL  RB568
          LD    DE,104H
          CALL  RB5681
          RET
;
;/*** sub. ***/

;***********************
;     SEND CSIO SUB.   *
;***********************
; I/P = D
; REG = -

TX_CSIO:  PUSH  AF

TX1_CSIO: LD    A,0
          OUT0  (CNTR),A
;
          OUT0  (TRDR),D
          SET   BIT_TX,A               ;Tx enable
          OUT0  (CNTR),A

TX2_CSIO: IN0   A,(CNTR)
          BIT   BIT_TX,A
          JR    NZ,TX2_CSIO
          POP   AF
          RET
;
;***********************
;    RECIVE CSIO SUB.  *
;***********************
; I/P =  -
; O/P =  D

RX_CSIO:  PUSH AF
;
          LD    A,0
          OUT0  (CNTR),A
          SET   BIT_RX,A          ;Rx  enable
          OUT0  (CNTR),A

RX1_CSIO: IN0   A,(CNTR)
          BIT   BIT_RX,A
          JR    NZ,RX1_CSIO

          IN0   D,(TRDR)
          POP   AF
          RET

;
;***********************
;   EWDS SUB 46,56,66  *
;***********************

EWDS4616: LD    DE,1
          CALL  EWDS
          RET
;
EWDS468:  LD    DE,2
          CALL  EWDS
          RET
;
EWDS5616:
EWDS6616: LD    DE,3
          CALL  EWDS
          RET
;
EWDS568:
EWDS668:  LD    DE,4
          CALL  EWDS
          RET
;
EWDS:     LD    B,1               ;EWDS COMMAND. 1 00 00 XXXX
          LD    C,00000000B
          CALL  S_COMM
          RET
;
;***********************
;   EWEN SUB 46,56,66  *
;***********************

EWEN4616: LD    DE,1
          CALL  EWEN
          RET
;
EWEN468:  LD    DE,2
          CALL  EWEN
          RET
;
EWEN5616:
EWEN6616: LD    DE,3
          CALL  EWEN
          RET
;
EWEN568:
EWEN668:  LD    DE,4
          CALL  EWEN
          RET
;
EWEN:     LD    B,1               ;EWEN COMMAND. 1 00 11 XXXX
          LD    C,00110000B
          CALL  S_COMM
          RET
;
;***********************
;  ERASE SUB 46,56,66  *
;***********************
;
ERASE4616: LD    DE,1
          CALL  ERASE
          RET
;
ERASE468: LD    DE,2
          CALL  ERASE
          RET
;
ERASE5616:
ERASE6616: LD    DE,3
          CALL  ERASE
          RET
;
ERASE568:
ERASE668: LD    E,4
          CALL  ERASE
          RET
;
ERASE:    LD    B,1               ;ERASE COMMAND. 1 11 543210
          LD    C,11000000B
          CALL  S_ADDR
          CALL  RES_CS            ;CS=0
          RET
;
;***********************
;   WRITE 8 BIT IN L   *
;***********************

WR8:      CALL  WR_CMD
          LD    D,L
          CALL  MSB
          CALL  TX_CSIO
          CALL  RES_CS
          CALL  EWDS
          RET
;
;***********************
;  WRITE 16 BIT  IN H  *
;***********************

WR16:     CALL  WR_CMD
          PUSH  HL
          POP   BC
          CALL  MSB_BC
;
          LD    D,B
          LD    B,C
          LD    C,D
          CALL  TX_BC
          CALL  RES_CS
          CALL  EWDS
          RET
;
;***********************
;     WRITE COMMAND.   *
;***********************

WR_CMD:   PUSH  AF
          CALL  EWEN
          CALL  ERASE
          POP   AF
          LD    B,1
          LD    C,01000000B
          CALL  S_ADDR
          RET
;
;***********************
;   READ DATA 16 TO HL *
;***********************

RD16:     LD    B,1
          LD    C,10000000B
          CALL  S_ADDR
;
          CALL  RX_CSIO
          LD    B,D
          CALL  RX_CSIO
          LD    C,D
;
          CALL  RES_CS
          CALL  MSB_BC
          LD    H,C
          LD    L,B
          RET
;
;***********************
;    READ DATA 8 TO L  *
;***********************

RD8:      LD    B,1
          LD    C,10000000B
          CALL  S_ADDR
;
          CALL  RX_CSIO
          CALL  MSB
          LD    L,D
          CALL  RES_CS
          RET

;***********************
;     SEND COMMAND.    *
;***********************

S_COMM:   PUSH  DE
          CALL  RES_CS
;
S_COMM0:  DEC   E
          JR    Z,S_COMM1
          SLA   C
          RL    B
          JR    S_COMM0
;
S_COMM1:  CALL  MSB_BC
          CALL  SET_CS
          CALL  TX_BC
          CALL  RES_CS
          POP   DE
          RET
;
;***********************
;  SEND ADDR. 46,56,66 *
;***********************

S_ADDR:   PUSH  DE
          CALL  RES_CS
;
S_ADDR0:  DEC   E
          JR    Z,S_ADR1
          SLA   C
          RL    B
          JR    S_ADDR0
;
S_ADR1:   OR    C
          LD    C,A
          LD    A,B
          OR    D
          LD    B,A
          CALL  MSB_BC
          CALL  SET_CS            ;CS  SET
          CALL  TX_BC
          POP   DE
          RET
;
;***********************
;        SEND BC       *
;***********************

TX_BC:    LD    D,B
          CALL  TX_CSIO
          LD    D,C
          CALL  TX_CSIO
          RET
;
;
;***********************
;      SET CS  = 1     *
;***********************
;
SET_CS:   PUSH  AF
          IN0   A,(CNTLA0)
          SET   BIT_RTS,A
          OUT0  (CNTLA0),A
          POP   AF
          RET

;***********************
;      RES CS  = 0     *
;***********************
;
RES_CS:   PUSH  AF
          IN0   A,(CNTLA0)
          RES   BIT_RTS,A
          OUT0  (CNTLA0),A
;
          XOR   A
RES_CS1:  NOP
          DEC   A
          JR    NZ,RES_CS1

          POP   AF
          RET
;
;**************************
;     WRITE  8 BIT SUB.   *
;**************************

WR_BL8:   LD    C,0
WR_BL81:  PUSH  BC
          PUSH  DE
          LD    A,C
          LD    L,(IX+0)
          CALL  WR8
          POP   DE
          POP   BC
          INC   IX
          INC   C
          DJNZ  WR_BL81
          RET
;
;***************************
;     WRITE 16 BIT  SUB.   *
;***************************

WR_BL16:  LD    C,0
WR_BL161: PUSH  BC
          PUSH  DE
          LD    A,C
          LD    H,(IX+0)
          INC   IX
          LD    L,(IX+0)
          CALL  WR16
          POP   DE
          POP   BC
          INC   IX
          INC   C
          DJNZ  WR_BL161
          RET
;
;
;**************************
;      READ 8 BIT SUB.    *
;**************************

RD_BL8:   LD    C,0
RD_BL81:  PUSH  BC
          PUSH  DE
          LD    A,C
          CALL  RD8
          LD    (IX+0),L
          POP   DE
          POP   BC
          INC   IX
          INC   C
          DJNZ  RD_BL81
          RET
;
;*************************
;     READ 16 BIT SUB.   *
;*************************

RD_BL16:  LD    C,0
RD_BL161: PUSH  BC
          PUSH  DE
          LD    A,C
          CALL  RD16
          LD    (IX+0),H
          INC   IX
          LD    (IX+0),L
          POP   DE
          POP   BC
          INC   IX
          INC   C
          DJNZ  RD_BL161
          RET

;***********************
;   ROTATE LSB-> MSB   *
;***********************
; I/P =  D
; O/P =  D

MSB:      PUSH  BC
          LD    B,8
MSB1:     RRC   D
          RL    C
          DJNZ  MSB1
          LD    D,C
          POP   BC
          RET
;
;***********************
;      MSB BC SUB.     *
;***********************
; rotate low byte -> high byte of BC

MSB_BC:   LD    D,B
          CALL  MSB
          LD    B,D
          LD    D,C
          CALL  MSB
          LD    C,D
          RET


